package user;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * NormalizeyFilter.java
 * Calculate  Normalize in the y direction from 1 to 0 
 * @version 1.0
 * @author Scott Klasky 
 */

public class NormalizeyFilter extends Filter {

  public NormalizeyFilter() {
     // output data set's dimension is 1 and no arg needs
     super(DataSet.ONED); 
  }

  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr; 
     int points;
     float max,min;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();
        yarr = onetimedata.getyArr();
		
        max = yarr[1];
	min = yarr[1];
        for (int j=0; j<points; j++)  {
	   if (yarr[j] <= min) min = yarr[j];
	}

        for (int j=0; j<points; j++)  {
           yarr[j] = yarr[j] - min;
           if (yarr[j] >= max) max = yarr[j];
	}

        for (int j=0; j<points; j++)  {
           yarr[j] = yarr[j] / max;
	}

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, 
                                                         xarr, yarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("Normalize:" + dataSet.getTitle(), timeDataVec);
  }

}





