package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * @version 1.0
 * @author Byeongseob Ki
 */

public class CAddXFVec extends Filter {

  public CAddXFVec() {
     // output data set's dimension is 1 and 1 arg needs
     super(DataSet.ONED, 1); 
     label = "Enter the constant c: ";
  }

  public Object performFilter() {

     TimeDataVec onetimedata;
     DataSetVec dataSet = (DataSetVec)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr;
     int points;

     float c = args[0];
     

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeDataVec)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();

        float[] xxarr = new float[points];

        for (int j=0; j<points; j++) {
           xxarr[j] = xarr[j] + c;
        }
               
        onetimedata = new TimeDataVec(dataSet.getTimeValue(i), 
                          xxarr, onetimedata.getyArr(), 
                          onetimedata.getrArr(), onetimedata.gettArr());
        timeDataVec.addElement(onetimedata);
     }
     return new DataSetVec("tested:  " + dataSet.getTitle(), timeDataVec);
  }

}


