package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * @version 1.0 
 * @author Byeongseob Ki
 */

public class CAddYF2D extends Filter {
    
  public CAddYF2D() {
     // output data set's dimension is 2 and 1 arg needs
     super(DataSet.TWOD, 1); 
     label = "Enter the constant c: ";
  }

  public Object performFilter() {

     TimeData2D onetimedata;
     DataSet2D dataSet = (DataSet2D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] yarr;
     int points;

     float c = args[0];
     

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        yarr = onetimedata.getyArr();

        float[] yyarr = new float[points];

        for (int j=0; j<points; j++) {
           yyarr[j] = yarr[j] + c;
        }
               
        onetimedata = new TimeData2D(dataSet.getTimeValue(i), points, 
                         onetimedata.getxArr(), yyarr, onetimedata.getzArr());
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet2D("tested:  " + dataSet.getTitle(), timeDataVec);
  }

}





