package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * CMultFXDataSet.java
 * Calculate 1/x
 * @version 1.0
 * @author Byeongseob Ki
 */

public class CMultFXFilter extends Filter {

  public CMultFXFilter() {
     // output data set's dimension is 1 and 1 arg needs
     super(DataSet.ONED, 1); 
     label = "Enter the constant c: ";
  }

  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;

     float c = args[0];

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();
        yarr = onetimedata.getyArr();

        for (int j=0; j<points; j++) 
           yarr[j] =yarr[j] * c;

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, xarr, yarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("f(x)=cf(x) :  " + dataSet.getTitle(), timeDataVec);
  }

}





