package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * @version 1.0
 * @author Byeongseob Ki
 */

public class CMultXF2D extends Filter {

  public CMultXF2D() {
     // output data set's dimension is 2 and 1 arg needs
     super(DataSet.TWOD, 1); 
     label = "Enter the constant c: ";
  }

  public Object performFilter() {

     TimeData2D onetimedata;
     DataSet2D dataSet = (DataSet2D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr;
     int points;

     float c = args[0];

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();

        float[] xxarr = new float[points];

        for (int j=0; j<points; j++) {
           xxarr[j] = xarr[j] * c;
        }
               
        onetimedata = new TimeData2D(dataSet.getTimeValue(i), points, 
                          xxarr, onetimedata.getyArr(), onetimedata.getzArr());
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet2D("tested:  " + dataSet.getTitle(), timeDataVec);
  }

}





