package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * EveryNthXDataSet.java
 * Extract every n-th x values
 * @version 1.0
 * @author Byeongseob Ki
 */

public class EveryNthXFilter extends Filter {

  public EveryNthXFilter() {
     // output data set's dimension is 1 and 1 arg needs
     super(DataSet.ONED, 1); 
     label = "Enter the constant n: ";
  }


  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;

     int n = (int)args[0];

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        int dummyPoints = onetimedata.getnoOfPoints(); 
        float[] dummyXArr = onetimedata.getxArr();
        float[] dummyYArr = onetimedata.getyArr();

        if (n <= 0) n = 1;
        points = (int)(dummyPoints/n);

        xarr = new float[points];
        yarr = new float[points];

        for (int j=0; j<points; j++) {
           xarr[j] = dummyXArr[j*n];
           yarr[j] = dummyYArr[j*n];
        }

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, xarr, yarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("Every nth x: " + dataSet.getTitle(), timeDataVec);
  }

}





