package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * Extract1DYF2D.java
 * Extract 1d data set from 2d data set
 * @version 1.0
 * @author Byeongseob Ki
 */

public class Extract1DYF2D extends Filter {

  public Extract1DYF2D() {
     // output data set's dimension is 1 and 1 arg needs
     super(DataSet.ONED, 1); 
     label = "Enter the constant c: ";
  }

  public Object performFilter() {

     TimeData2D onetimedata;
     TimeData1D timedata;

     DataSet2D dataSet = (DataSet2D)sources.firstElement();

     Vector timeDataVec = new Vector();
     Vector xvec = new Vector();
     Vector fvec = new Vector();
     float[] xarr, farr;
     int points;

     float extraction = args[0];

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = dataSet.timeData[i];

        int dimx = onetimedata.getDimX();
        int dimy = onetimedata.getDimY();

        float[] dummyXArr = onetimedata.getxArr();
        float[] dummyYArr = onetimedata.getyArr();
        float[] dummyZArr = onetimedata.getzArr();

        int size = dummyYArr.length;
         for (int j=0; j<size; j++) {
	  if (extraction == dummyYArr[j]) { 
             xvec.addElement(new Float((float)dummyXArr[j]));
             fvec.addElement(new Float((float)dummyZArr[j]));
          }
        }

        size = xvec.size();
        xarr = new float[size];
        farr = new float[size];

        for (int j=0; j<size; j++) {
           xarr[j] = ((Float)xvec.elementAt(j)).floatValue();
           farr[j] = ((Float)fvec.elementAt(j)).floatValue();
        }

        xvec.removeAllElements();
        fvec.removeAllElements();

        if (size <= 0) {
           float closest = 0f, gap = 1.0e5f, gap2;
	   for (int k=0; k<dummyYArr.length; k++) {
             gap2 = Math.abs(dummyYArr[k] - extraction);
             if (gap2 < gap) {
                gap = gap2;
                closest = dummyYArr[k];
             }
           }
           System.out.println("There are no matching points!");
           System.out.println("Closest value is " + closest);
           return null;
        }

        timedata = new TimeData1D(dataSet.getTimeValue(i), size, xarr, farr);
        timeDataVec.addElement(timedata);
     }
     return new DataSet1D("Extracted over x from 2d: " + dataSet.getTitle(), timeDataVec);
  }

}





