package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * ExtractTimeF2D.java
 * Extract ranges over time
 * @version 1.0
 * @author Byeongseob Ki
 */

public class ExtractTimeF2D extends Filter {

  public ExtractTimeF2D() {
     // output data set's dimension is 1 and 1 arg needs
     super(DataSet.TWOD, 2); 
     label = "Enter the constants like start-end: ";
  }

  public Object performFilter() {
     DataSet2D dataSet = (DataSet2D)sources.firstElement();

     Vector timeDataVec = new Vector();

     int start = (int)args[0];
     int end = (int)args[1];

     if ((start < 1) || (start > dataSet.getnoOfTime())) start = 1;
     if (end > dataSet.getnoOfTime()) end = dataSet.getnoOfTime();

     for (int i=start; i<=end; i++) {
        timeDataVec.addElement(dataSet.timeData[i-1]);
     }

     return new DataSet2D("Extracted over time: " + dataSet.getTitle(), timeDataVec);
  }

}
