package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * ExtractXF2D.java
 * Extract ranges over x
 * @version 1.0
 * @author Byeongseob Ki
 */

public class ExtractXF2D extends Filter {

  public ExtractXF2D() {
     // output data set's dimension is 1 and 1 arg needs
     super(DataSet.TWOD, 2); 
     label = "Enter the constants like start-end: ";
  }

  public Object performFilter() {

     TimeData2D onetimedata;
     DataSet2D dataSet = (DataSet2D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr, zarr;
     int points;

     int start = (int)args[0];
     int end = (int)args[1];


     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = dataSet.timeData[i];

        int dimx = onetimedata.getDimX();
        int dimy = onetimedata.getDimX();

        float[] dummyXArr = onetimedata.getxArr();
        float[] dummyYArr = onetimedata.getyArr();
        float[] dummyZArr = onetimedata.getzArr();

        if ((start < 1) || (start > dimx)) start = 1;
        if (end > dimx) end = dimx;
        points = (end - start + 1) * dimy;

        xarr = new float[points];
        yarr = new float[points];
        zarr = new float[points];
       
        int index = 0, line = 0;
        int pos;

        for (int ix=0; ix<dimy; ix++) {        
           for (int j=start; j<=end; j++) {
             pos = line*dimx + j - 1;
             xarr[index] = dummyXArr[pos];
             yarr[index] = dummyYArr[pos];
             zarr[index] = dummyZArr[pos];
             index++;
           } 
           line++;
        }

        onetimedata = new TimeData2D(dataSet.getTimeValue(i), points, 
                                                  xarr, yarr, zarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet2D("Extracted over x: " + dataSet.getTitle(), timeDataVec);
  }

}





