package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * ExtractXDataSet.java
 * Extract ranges over x
 * @version 1.0
 * @author Byeongseob Ki
 */

public class ExtractXFilter extends Filter {

  public ExtractXFilter() {
     // output data set's dimension is 1 and 1 arg needs
     super(DataSet.ONED, 2); 
     label = "Enter the constants like start-end: ";
  }

  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;

     int start = (int)args[0];
     int end = (int)args[1];

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        int dummyPoints = onetimedata.getnoOfPoints(); 
        float[] dummyXArr = onetimedata.getxArr();
        float[] dummyYArr = onetimedata.getyArr();

        if ((start < 1) || (start > dummyPoints)) start = 1;
        if (end > dummyPoints) end = dummyPoints;
        points = end - start + 1;

        xarr = new float[points];
        yarr = new float[points];

        for (int j=start; j<=end; j++) {
            xarr[j-start] = dummyXArr[j-1];
            yarr[j-start] = dummyYArr[j-1];
        }

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, xarr, yarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("Extracted over x: " + dataSet.getTitle(), timeDataVec);
  }

}





