package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * InverseDataSet.java
 * Inverse x <-> f(x)
 * @version 1.0
 * @author Byeongseob Ki
 */

public class InverseFilter extends Filter {

  public InverseFilter() {
    super(DataSet.ONED);          // output data set's dimension is 1
  }

  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();
 
     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getyArr();
        yarr = onetimedata.getxArr();

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, xarr, yarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("Inversed " + dataSet.getTitle(), timeDataVec);
  }

}





