package sv.user;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * LineFitFiler.java
 * Calculate's a least square fit
 * @version 1.0
 * @author Scott Klasky 
 */

public class LineFitFilter extends Filter {

  public LineFitFilter() {
    super(DataSet.ONED);          // output data set's dimension is 1
  }

  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;
     float sx, sy, sxoss, t, st2;
     float a,b;
     int ss;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();
        yarr = onetimedata.getyArr();
        sx = 0.0f;
        sy = 0.0f;
        st2 = 0.0f;
        b = 0.0f;

        for (int j=0; j<points; j++)  {
           sx += xarr[j];
           sy += yarr[j];
        }
        ss = points;
        sxoss = sx/ss;
        for (int j=0; j<points; j++)  {
           t = xarr[j]-sxoss; 
           st2+= t*t;
           b+=t*yarr[j];
        }
        b/=st2;
        a=(sy-sx*b)/ss;
        System.out.println("Time="+dataSet.getTimeValue(i)+" a= "+a + "b="+b);

        for (int j=0; j<points; j++)  {
           yarr[j] = a + b * xarr[j];
        }

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, xarr, yarr); 
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("ln(f(x)) :  " + dataSet.getTitle(), timeDataVec);
  }

}





