package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * @version 1.0
 * @author Byeongseob Ki
 */

public class LnXF2D extends Filter {

  public LnXF2D() {
    super(DataSet.TWOD);          // output data set's dimension is 2
  }

  public Object performFilter() {

     TimeData2D onetimedata;
     DataSet2D dataSet = (DataSet2D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr;
     int points;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();

        float[] xxarr = new float[points];

        for (int j=0; j<points; j++) {
	  if (xarr[j] <= 0.0f) {
            System.out.println("Can't perform filter because x is less than 0");
            return null;
          }
        }

        for (int j=0; j<points; j++) {
           xxarr[j] =  (float)Math.log((float)xarr[j]);
        }
               
        onetimedata = new TimeData2D(dataSet.getTimeValue(i), points, 
                          xxarr, onetimedata.getyArr(), onetimedata.getzArr());
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet2D("tested:  " + dataSet.getTitle(), timeDataVec);
  }

}





