package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * LnXDataSet.java
 * Calculate 1/x
 * @version 1.0
 * @author Byeongseob Ki
 */

public class LnXFilter extends Filter {

  public LnXFilter() {
    super(DataSet.ONED);          // output data set's dimension is 1
  }

  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();
        yarr = onetimedata.getyArr();

        int pp = 0;

        for (int j=0; j<points; j++) {
           if (xarr[j] != 0.0f) pp++;}

        float[] xxarr = new float[pp];
        float[] yyarr = new float[pp];
        pp = 0;
        for (int j=0; j<points; j++) {
           
           if (xarr[j] != 0.0f){
              xxarr[pp] = (float)Math.log(xarr[j]);
              yyarr[pp] = yarr[j];
              pp++;
           }
        }
               
        points = pp;

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, xxarr, yyarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("ln(x) :  " + dataSet.getTitle(), timeDataVec);
  }

}





