package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * Log10XDataSet.java
 * Calculate 1/x
 * @version 1.0
 * @author Byeongseob Ki
 */

public class Log10XFilter extends Filter {

  public Log10XFilter() {
    super(DataSet.ONED);          // output data set's dimension is 1
  }


  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();
        yarr = onetimedata.getyArr();

        for (int j=0; j<points; j++) 
           xarr[j] = (float)(Math.log(xarr[j]) / 2.3025851);

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, xarr, yarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("log10(x) :  " + dataSet.getTitle(), timeDataVec);
  }

}





