package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * MergeAddF2D.java
 * merge two windows(adding)
 * @version 1.0
 * @author Byeongseob Ki
 */

public class MergeAddF2D extends Filter {

  public MergeAddF2D() {
      // output data set's dimension is 2 and 1 arg needs
     super(DataSet.TWOD, 0, 2); 
  }

  public Object performFilter() {

     DataSet2D dataSet1 = (DataSet2D)sources.elementAt(0);
     DataSet2D dataSet2 = (DataSet2D)sources.elementAt(1);

     String title = dataSet1.getTitle() + "+" + dataSet2.getTitle();

     int sz = dataSet1.timeData.length;
     if (sz != dataSet2.timeData.length) {
        System.out.println("Merge two GraphFrames has failed ...");
        return null;
     }

     float[] xArr, yArr, zArr;
     Vector timedVec = new Vector();
     for (int j=0; j<sz; j++) {
         float this_time = dataSet1.timeData[j].getTime();

         if (this_time != dataSet2.timeData[j].getTime()) {
             System.out.println("Merge two GraphFrames has failed ...");
             return null;
         }
      
         float[] xArr1 = dataSet1.timeData[j].getxArr();
         float[] yArr1 = dataSet1.timeData[j].getyArr();
         float[] zArr1 = dataSet1.timeData[j].getzArr();
         float[] xArr2 = dataSet2.timeData[j].getxArr();
         float[] yArr2 = dataSet2.timeData[j].getyArr();
         float[] zArr2 = dataSet2.timeData[j].getzArr();

         if ((xArr1.length != xArr2.length) || (yArr1.length != yArr2.length))
            return null;

         xArr = xArr1;
         yArr = yArr1;
         zArr = new float[xArr1.length];

         for (int i=0; i<xArr1.length; i++) {
            if ((xArr1[i] == xArr2[i]) && (yArr1[i] == yArr2[i]))
               zArr[i] = zArr1[i] + zArr2[i];
            else
               zArr[i] = 0.0f;
         }

         timedVec.addElement(new TimeData2D(this_time, xArr.length, 
                                                  xArr, yArr, zArr));
     }
     return new DataSet2D(title, timedVec);
  }
}





