package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * MergeDivDataSet.java
 * merge two windows(dividing)
 * @version 1.0
 * @author Byeongseob Ki
 */

public class MergeDivFilter extends Filter {

  public MergeDivFilter() {
      // output data set's dimension is 1 and 1 arg needs
     super(DataSet.ONED, 0, 2); 
  }

  public Object performFilter() {

     DataSet1D dataSet1 = (DataSet1D)sources.elementAt(0);
     DataSet1D dataSet2 = (DataSet1D)sources.elementAt(1);

     String title = dataSet1.getTitle() + "/" + dataSet2.getTitle();

     int sz = dataSet1.timeData.length;
     if (sz != dataSet2.timeData.length) {
        System.out.println("Merge two GraphFrames is failed ...");
        return null;
     }

     Vector timedVec = new Vector();
     for (int j=0; j<sz; j++) {
         float this_time = dataSet1.timeData[j].getTime();

         if (this_time != dataSet2.timeData[j].getTime()) {
             System.out.println("Merge two GraphFrames is failed ...");
             return null;
         }
 
         float[] xArr1 = dataSet1.timeData[j].getxArr();
         float[] yArr1 = dataSet1.timeData[j].getyArr();
         float[] xArr2 = dataSet2.timeData[j].getxArr();
         float[] yArr2 = dataSet2.timeData[j].getyArr();

         Vector xres = new Vector();
         Vector yres = new Vector();        

         for (int i=0; i<xArr1.length; i++) {
            for (int k=0; k<xArr2.length; k++) {
	      if ((xArr1[i] == xArr2[k]) && (yArr2[k] != 0.0f)) {
                 xres.addElement(new Float(xArr1[i]));
                 yres.addElement(new Float(yArr1[i] / yArr2[k]));
                 break;
              }
            }
         }

         float[] xArr = new float[xres.size()];	
         float[] yArr = new float[yres.size()];
         for (int i=0; i<xres.size(); i++) {
            xArr[i] = ((Float)xres.elementAt(i)).floatValue();
            yArr[i] = ((Float)yres.elementAt(i)).floatValue();
         }
        
        timedVec.addElement(new TimeData1D(this_time, xArr.length, xArr, yArr));
     }
     return new DataSet1D(title, timedVec);
  }

}





