package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;
import sv.util.*;

/** 
 * NormInfDataSet.java
 * Calculate inf-dim norm
 * @version 1.0
 * @author Byeongseob Ki
 */

public class NormInfFilter extends Filter {

  public NormInfFilter() {
    super(DataSet.ONED);          // output data set's dimension is 1
  }

  public Object performFilter() {

     TimeData1D dummydata; 
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;

     xarr = new float[dataSet.getnoOfTime()];
     yarr = new float[dataSet.getnoOfTime()];
     float value = 0.0f;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        xarr[i] = dataSet.getTimeValue(i);
        dummydata = (TimeData1D)dataSet.timeData[i];
        float[] tmparr = dummydata.getyArr();

        Sorter sorter = new Sorter();
        sorter.QSortFloat(tmparr, 0, dummydata.getnoOfPoints()-1);
        yarr[i] = tmparr[dummydata.getnoOfPoints()-1];
     }
     timeDataVec.addElement(new TimeData1D(0.0f, dataSet.getnoOfTime(), xarr, yarr));
     return new DataSet1D("Norm Inf  " + dataSet.getTitle(), timeDataVec);
  }

}





