package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * NormTwoDataSet.java
 * Calculate 1-dim norm
 * @version 1.0
 * @author Byeongseob Ki
 */

public class NormTwoFilter extends Filter {

  public NormTwoFilter() {
    super(DataSet.ONED);          // output data set's dimension is 1
  }

  public Object performFilter() {

     TimeData1D dummydata; 
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;

     xarr = new float[dataSet.getnoOfTime()];
     yarr = new float[dataSet.getnoOfTime()];
     float value = 0.0f;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        xarr[i] = dataSet.getTimeValue(i);
        dummydata = (TimeData1D)dataSet.timeData[i];
        float[] tmparr = dummydata.getyArr();

        value = 0.0f;
        for (int j=0; j<dummydata.getnoOfPoints(); j++) 
           value = value + tmparr[j] * tmparr[j];

        yarr[i] = (float)Math.sqrt(value / (dummydata.getnoOfPoints() 
                                     * dummydata.getnoOfPoints()));
     }
     timeDataVec.addElement(new TimeData1D(0.0f, dataSet.getnoOfTime(), xarr, yarr));
     return new DataSet1D("Norm 2  " + dataSet.getTitle(), timeDataVec);
  }

}





