package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * OneOverXDataSet.java
 * Calculate 1/x
 * @version 1.0
 * @author Byeongseob Ki
 */

public class OneOverXFilter extends Filter {

  public OneOverXFilter() {
    super(DataSet.ONED);          // output data set's dimension is 1
  }

  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();
        yarr = onetimedata.getyArr();

        for (int j=0; j<points; j++) {
            if (xarr[j] == 0.0f) xarr[j] = 0.0f;
            else xarr[j] = 1.0f / xarr[j];
        }

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, xarr, yarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("1/x :  " + dataSet.getTitle(), timeDataVec);
  }

}





