package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;

/** 
 * @version 1.0
 * @author Byeongseob Ki
 */

public class RotateFVec extends Filter {

  public RotateFVec() {
     // output data set's dimension is 2 and 1 arg needs
     super(DataSet.ONED, 1); 
     label = "Enter the angle c (radian): ";
  }

  public Object performFilter() {

     TimeDataVec onetimedata;
     DataSetVec dataSet = (DataSetVec)sources.firstElement();

     Vector timeDataVec = new Vector();
     float[] tarr;
     int points;

     float c = args[0];
     

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeDataVec)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        tarr = onetimedata.gettArr();

        float[] ttarr = new float[points];

        for (int j=0; j<points; j++) {
           ttarr[j] = tarr[j] + c;
        }
               
        onetimedata = new TimeDataVec(dataSet.getTimeValue(i), 
                          onetimedata.getxArr(), onetimedata.getyArr(), 
                          onetimedata.getrArr(), ttarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSetVec("tested:  " + dataSet.getTitle(), timeDataVec);
  }

}


