package user.dist;

import java.util.*;
import java.awt.*;

import sv.kernel.*;
import sv.util.*;

/** 
 * SortDataSet.java
 * Sort data with respect to x
 * @version 1.0
 * @author Byeongseob Ki
 */

public class SortFilter extends Filter {

  public SortFilter() {
    super(DataSet.ONED);          // output data set's dimension is 1
  }


  public Object performFilter() {

     TimeData1D onetimedata;
     DataSet1D dataSet = (DataSet1D)sources.firstElement();
 
     Vector timeDataVec = new Vector();
     float[] xarr, yarr;
     int points;
     Sorter sorter = new Sorter();

     for (int i=0; i<dataSet.getnoOfTime(); i++) {
        onetimedata = (TimeData1D)dataSet.timeData[i];
        points = onetimedata.getnoOfPoints();

        xarr = onetimedata.getxArr();
        yarr = onetimedata.getyArr();

        sorter.QSortFloat2(xarr, yarr, 0, points-1);

        onetimedata = new TimeData1D(dataSet.getTimeValue(i), points, xarr, yarr);
        timeDataVec.addElement(onetimedata);
     }
     return new DataSet1D("Sorted " + dataSet.getTitle(), timeDataVec);
  }

}





